Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/obj/Release/BuildLog.htm
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/obj/Release/BuildLog.htm	(revision 777)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/obj/Release/BuildLog.htm	(revision 779)
@@ -12,20 +12,20 @@
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Command Lines
-</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creating temporary file "d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\RSP000010.rsp" with contents
+</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creating temporary file "d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\RSP00002F.rsp" with contents
 [
-/O2 /Op /Ot /GL /G6 /GA /I "..\include" /I "..\..\Common\include" /I "..\..\..\OgreMain\include" /I "..\..\OgreIllumModule\include" /I "..\..\OgreIllumModule\include\RenderTechniques" /I "..\..\OgreIllumModule\include\RenderingRuns" /I "..\..\IllumModule\include\RenderTechniques" /I "..\..\IllumModule\include" /I "..\..\IllumModule\include\RenderingRuns" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "GAMETOOLS_ILLUMINATION_MODULE" /D "_MBCS" /Gm /EHsc /MD /Fo"..\obj\Release/" /Fd"..\obj\Release/vc70.pdb" /W3 /c /Wp64 /Zi /TP
-\ogre_gametools\Samples\GameToolsParticleDemo\src\GameToolsParticleDemo.cpp
+/O2 /Op /Ot /GL /G6 /GA /I "..\include" /I "D:\ogre_gametools\Samples\Common\include" /I "D:\ogre_gametools\OgreMain\include" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include" /I "..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /Gm /EHsc /MD /Fo"..\obj\Release/" /Fd"..\obj\Release/vc70.pdb" /W3 /c /Wp64 /Zi /TP
+\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\src\GameToolsParticleDemo.cpp
 ]
-Creating command line "cl.exe @d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\RSP000010.rsp /nologo"
-Creating temporary file "d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\RSP000011.rsp" with contents
+Creating command line "cl.exe @d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\RSP00002F.rsp /nologo"
+Creating temporary file "d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\RSP000030.rsp" with contents
 [
-/OUT:"..\bin\Release/GameToolsParticleDemo.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"..\..\illumModule\bin\Release" /LIBPATH:"..\..\..\OgreMain\lib\Release" /LIBPATH:"..\..\OgreIllumModule\bin\Release" /SUBSYSTEM:WINDOWS /OPT:REF /OPT:ICF /OPT:NOWIN98 /LTCG /MACHINE:X86 OgreMain.lib IllumModule_Ogre.lib IllumModule.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
-\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\GameToolsParticleDemo.obj
+/OUT:"..\bin\Release/GameToolsParticleDemo.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\bin\Release" /LIBPATH:"D:\ogre_gametools\OgreMain\lib\Release" /LIBPATH:"..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\bin\Release" /SUBSYSTEM:WINDOWS /OPT:REF /OPT:ICF /OPT:NOWIN98 /LTCG /MACHINE:X86 OgreMain.lib IllumModule_Ogre.lib IllumModule.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
+\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\GameToolsParticleDemo.obj
 ]
-Creating command line "link.exe @d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\RSP000011.rsp"
-Creating temporary file "d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\BAT000012.bat" with contents
+Creating command line "link.exe @d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\RSP000030.rsp"
+Creating temporary file "d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\BAT000031.bat" with contents
 [
 @echo off
-copy ..\bin\Release\GameToolsParticleDemo.exe ..\..\Common\Bin\Release
+copy ..\bin\Release\GameToolsParticleDemo.exe ..\..\..\bin\Release
 if errorlevel 1 goto VCReportError
 goto VCEnd
@@ -35,5 +35,5 @@
 :VCEnd
 ]
-Creating command line "d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\BAT000012.bat"
+Creating command line "d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\BAT000031.bat"
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Output Window
@@ -48,5 +48,5 @@
 Results
 </font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>
-Build log was saved at "file://d:\ogre_gametools\Samples\GameToolsParticleDemo\obj\Release\BuildLog.htm"
+Build log was saved at "file://d:\ogresvn\Gtp\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\obj\Release\BuildLog.htm"
 GameToolsParticleDemo - 0 error(s), 0 warning(s)</pre></table><table   width=100% height=20 bgcolor=#CFCFE5><tr><td><font face=arial size=+2>
 </font></table></body></html>