Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/IllumModule_Ogre-ndsproperties.xml
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/IllumModule_Ogre-ndsproperties.xml	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/IllumModule_Ogre-ndsproperties.xml	(revision 783)
@@ -0,0 +1,9 @@
+<?xml version="1.0" encoding="utf-8"?>
+<NDSProject xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" supplier="Nokia">
+  <updateMmpFile>true</updateMmpFile>
+  <pkgFile>sis\IllumModule_Ogre.pkg</pkgFile>
+  <pkgUpdate>true</pkgUpdate>
+  <pkgGeneration>true</pkgGeneration>
+  <lang>EN</lang>
+  <updateContextHelp>true</updateContextHelp>
+</NDSProject>
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj	(revision 783)
@@ -0,0 +1,352 @@
+<?xml version="1.0" encoding="windows-1250"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="IllumModule_Ogre"
+	ProjectGUID="{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				ImproveFloatingPointConsistency="TRUE"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\include;..\include\RenderingRuns;..\include\RenderTechniques;..\..\IllumModule\include;..\..\IllumModule\include\RenderingRuns;..\..\IllumModule\include\RenderTechniques"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				AdditionalDependencies="IllumModule.lib OgreMain_d.lib"
+				AdditionalLibraryDirectories="..\..\IllumModule\bin\Debug;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2"
+			WholeProgramOptimization="TRUE">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="1"
+				EnableIntrinsicFunctions="TRUE"
+				ImproveFloatingPointConsistency="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
+				OptimizeForProcessor="2"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\include;..\include\RenderingRuns;..\include\RenderTechniques;..\..\IllumModule\include;..\..\IllumModule\include\RenderingRuns;..\..\IllumModule\include\RenderTechniques"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
+				StringPooling="TRUE"
+				MinimalRebuild="TRUE"
+				RuntimeLibrary="2"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				AdditionalDependencies="IllumModule.lib OgreMain.lib"
+				AdditionalLibraryDirectories="..\..\IllumModule\bin\Release;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
+			<File
+				RelativePath="..\src\OgreIlluminationManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderable.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderingRun.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderTechnique.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreSharedRuns.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreTechniqueGroup.cpp">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCausticCasterRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCausticRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreConvolvedCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreDepthShadowRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreDistanceCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreSBBRenderTechnique.cpp">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreCausticCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreColorCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreDepthShadowMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreDistanceCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgrePhotonMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreReducedCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\PreComputingRuns\OgreSceneCameraDepthRenderingRun.cpp">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc">
+			<File
+				RelativePath="..\include\OgreIlluminationManager.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderable.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderingRun.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderTechnique.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreSharedRuns.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreTechniqueGroup.h">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCausticCasterRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCausticRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreConvolvedCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreDepthShadowRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreDistanceCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreSBBRenderTechnique.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderingRuns\OgreCausticCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreColorCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreDepthShadowMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreDistanceCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgrePhotonMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreReducedCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreSceneCameraDepthRenderingRun.h">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="Media"
+			Filter="">
+			<Filter
+				Name="materials"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\EnvMetals.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools_Glow.compositor">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools_ToneMap.compositor">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\kupola.material">
+				</File>
+			</Filter>
+			<Filter
+				Name="programs"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools.program">
+				</File>
+			</Filter>
+			<Filter
+				Name="shaders"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Cau.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Caustic.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_CausticSoftShadow.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_CubeMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Depth.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_DepthShadow.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Distance.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Localized_EnvMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_LocalizedBump_EnvMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_PostProc.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_ReduceCubeMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_SoftShadow.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Sprite.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_UV.hlsl">
+				</File>
+			</Filter>
+			<Filter
+				Name="particles"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\particle\GameTools.particle">
+				</File>
+			</Filter>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.dsp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.dsp	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.dsp	(revision 783)
@@ -0,0 +1,111 @@
+# Microsoft Developer Studio Project File - Name="Demo_RenderToTexture" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Application" 0x0101
+
+CFG=Demo_RenderToTexture - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "Demo_RenderToTexture.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "Demo_RenderToTexture.mak" CFG="Demo_RenderToTexture - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "Demo_RenderToTexture - Win32 Release" (based on "Win32 (x86) Application")
+!MESSAGE "Demo_RenderToTexture - Win32 Debug" (based on "Win32 (x86) Application")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+MTL=midl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "Demo_RenderToTexture - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "..\bin\Release"
+# PROP BASE Intermediate_Dir "..\obj\Release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "..\bin\Release"
+# PROP Intermediate_Dir "..\obj\Release"
+# PROP Ignore_Export_Lib 1
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\include" /I "..\..\Common\include" /I "..\..\..\OgreMain\include" /D "NDEBUG" /D "_MBCS" /D "_WINDOWS" /D "WIN32" /YX /FD /c
+# SUBTRACT CPP /Fr
+# ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /win32
+# ADD MTL /nologo /D "NDEBUG" /mktyplib203 /win32
+# ADD BASE RSC /l 0x809 /d "NDEBUG"
+# ADD RSC /l 0x809 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:windows /machine:I386
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain.lib /nologo /subsystem:windows /machine:I386 /out:"../../Common/Bin/Release/Demo_RenderToTexture.exe" /libpath:"..\..\..\OgreMain\lib\release"
+# SUBTRACT LINK32 /profile /debug
+
+!ELSEIF  "$(CFG)" == "Demo_RenderToTexture - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "..\bin\Demo_RenderToTexture___Win32_Debug"
+# PROP BASE Intermediate_Dir "..\obj\Demo_RenderToTexture___Win32_Debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "..\bin\Debug"
+# PROP Intermediate_Dir "..\obj\Debug"
+# PROP Ignore_Export_Lib 1
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /YX /FD /GZ /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /ZI /Od /I "..\include" /I "..\..\Common\include" /I "..\..\..\OgreMain\include" /D "_MBCS" /D "_WINDOWS" /D "_DEBUG" /D "WIN32" /FD /GZ /c
+# SUBTRACT CPP /Fr /YX /Yc /Yu
+# ADD BASE MTL /nologo /D "_DEBUG" /mktyplib203 /win32
+# ADD MTL /nologo /D "_DEBUG" /mktyplib203 /win32
+# ADD BASE RSC /l 0x809 /d "_DEBUG"
+# ADD RSC /l 0x809 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:windows /debug /machine:I386 /pdbtype:sept
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain.lib /nologo /subsystem:windows /debug /machine:I386 /nodefaultlib:"LIBCMT" /out:"../../Common/Bin/Debug/Demo_RenderToTexture.exe" /pdbtype:sept /libpath:"..\..\..\OgreMain\lib\debug"
+# SUBTRACT LINK32 /verbose
+
+!ENDIF 
+
+# Begin Target
+
+# Name "Demo_RenderToTexture - Win32 Release"
+# Name "Demo_RenderToTexture - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE=..\src\RenderToTexture.cpp
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# End Group
+# Begin Group "Resource Files"
+
+# PROP Default_Filter "ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe"
+# End Group
+# End Target
+# End Project
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Repository
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Repository	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Repository	(revision 783)
@@ -0,0 +1,1 @@
+ogrenew/Samples/RenderToTexture/scripts
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Root
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Root	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Root	(revision 783)
@@ -0,0 +1,1 @@
+:pserver:anonymous@cvs.sourceforge.net:/cvsroot/ogre
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Entries
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Entries	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Entries	(revision 783)
@@ -0,0 +1,3 @@
+/Demo_RenderToTexture.dsp/1.2/Wed Oct  6 00:04:08 2004/-kb/Tv1-0-0
+/Demo_RenderToTexture.vcproj/1.6/Tue Nov  2 21:52:41 2004//Tv1-0-0
+D
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Tag
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Tag	(revision 783)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/CVS/Tag	(revision 783)
@@ -0,0 +1,1 @@
+Nv1-0-0